"use strict";

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.customFilter = exports.dateFilter = exports.numberFilter = exports.multiSelectFilter = exports.selectFilter = exports.textFilter = exports.ComparatorNumber = exports.LE = exports.LT = exports.GE = exports.GT = exports.NE = exports.EQ = exports.LIKE = exports.FILTER_DELAY = exports.FILTER_TYPES = void 0;
var date_1 = __importDefault(require("./src/components/date"));
var multiselect_1 = __importDefault(require("./src/components/multiselect"));
var number_1 = __importDefault(require("./src/components/number"));
var select_1 = __importDefault(require("./src/components/select"));
var text_1 = __importDefault(require("./src/components/text"));
var context_1 = __importDefault(require("./src/context"));
var FILTER_TYPES;
(function (FILTER_TYPES) {
  FILTER_TYPES["TEXT"] = "TEXT";
  FILTER_TYPES["SELECT"] = "SELECT";
  FILTER_TYPES["MULTISELECT"] = "MULTISELECT";
  FILTER_TYPES["NUMBER"] = "NUMBER";
  FILTER_TYPES["DATE"] = "DATE";
})(FILTER_TYPES || (exports.FILTER_TYPES = FILTER_TYPES = {}));
exports.FILTER_DELAY = 500;
/**
 * Filter comparators used for table filters
 */
exports.LIKE = "LIKE";
exports.EQ = "=";
exports.NE = "!=";
exports.GT = ">";
exports.GE = ">=";
exports.LT = "<";
exports.LE = "<=";
exports.ComparatorNumber = 7;
var textFilter = function textFilter() {
  var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  return {
    Filter: text_1["default"],
    props: props
  };
};
exports.textFilter = textFilter;
var selectFilter = function selectFilter() {
  var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  return {
    Filter: select_1["default"],
    props: props
  };
};
exports.selectFilter = selectFilter;
var multiSelectFilter = function multiSelectFilter() {
  var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  return {
    Filter: multiselect_1["default"],
    props: props
  };
};
exports.multiSelectFilter = multiSelectFilter;
var numberFilter = function numberFilter() {
  var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  return {
    Filter: number_1["default"],
    props: props
  };
};
exports.numberFilter = numberFilter;
var dateFilter = function dateFilter() {
  var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  return {
    Filter: date_1["default"],
    props: props
  };
};
exports.dateFilter = dateFilter;
var customFilter = function customFilter() {
  var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  return {
    Filter: function Filter() {},
    props: props
  };
};
exports.customFilter = customFilter;
// declare function filterFactory(props?: FilterFactoryProps): unknown;
// export default filterFactory;
exports["default"] = function () {
  var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  return {
    createContext: context_1["default"],
    options: options
  };
};