"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};
Object.defineProperty(exports, "__esModule", {
  value: true
});
/* eslint react/prop-types: 0 */
/* eslint react/require-default-props: 0 */
/* eslint camelcase: 0 */
var prop_types_1 = __importDefault(require("prop-types"));
var react_1 = __importDefault(require("react"));
var __1 = require("..");
var filter_1 = require("./filter");
exports["default"] = function (_, isRemoteFiltering, handleFilterChange) {
  var FilterContext = react_1["default"].createContext({});
  var FilterProvider = /*#__PURE__*/function (_react_1$default$Comp) {
    _inherits(FilterProvider, _react_1$default$Comp);
    var _super = _createSuper(FilterProvider);
    function FilterProvider(props) {
      var _this;
      _classCallCheck(this, FilterProvider);
      _this = _super.call(this, props);
      _this.currFilters = {};
      _this.clearFilters = {};
      _this.onFilter = _this.onFilter.bind(_assertThisInitialized(_this));
      _this.doFilter = _this.doFilter.bind(_assertThisInitialized(_this));
      _this.onExternalFilter = _this.onExternalFilter.bind(_assertThisInitialized(_this));
      _this.data = props.data;
      _this.isEmitDataChange = false;
      return _this;
    }
    _createClass(FilterProvider, [{
      key: "componentDidMount",
      value: function componentDidMount() {
        if (isRemoteFiltering() && Object.keys(this.currFilters).length > 0) {
          handleFilterChange(this.currFilters);
        }
      }
    }, {
      key: "onFilter",
      value: function onFilter(column, filterType) {
        var _this2 = this;
        var initialize = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
        return function (filterVal) {
          // watch out here if migration to context API, #334
          var currFilters = Object.assign({}, _this2.currFilters);
          _this2.clearFilters = {};
          var dataField = column.dataField,
            filter = column.filter;
          var needClearFilters = !_.isDefined(filterVal) || filterVal === "" || filterVal.length === 0;
          if (needClearFilters) {
            delete currFilters[dataField];
            _this2.clearFilters = _defineProperty({}, dataField, {
              clear: true,
              filterVal: filterVal
            });
          } else {
            // select default comparator is EQ, others are LIKE
            var _filter$props = filter.props,
              _filter$props$compara = _filter$props.comparator,
              comparator = _filter$props$compara === void 0 ? filterType === __1.FILTER_TYPES.SELECT ? __1.EQ : __1.LIKE : _filter$props$compara,
              _filter$props$caseSen = _filter$props.caseSensitive,
              caseSensitive = _filter$props$caseSen === void 0 ? false : _filter$props$caseSen;
            currFilters[dataField] = {
              filterVal: filterVal,
              filterType: filterType,
              comparator: comparator,
              caseSensitive: caseSensitive
            };
          }
          _this2.currFilters = currFilters;
          if (isRemoteFiltering()) {
            if (!initialize) {
              handleFilterChange(_this2.currFilters);
            }
            return;
          }
          _this2.doFilter(_this2.props);
        };
      }
    }, {
      key: "onExternalFilter",
      value: function onExternalFilter(column, filterType) {
        var _this3 = this;
        return function (value) {
          _this3.onFilter(column, filterType)(value);
        };
      }
    }, {
      key: "getFiltered",
      value: function getFiltered() {
        return this.data;
      }
      // componentDidUpdate(nextProps: FilterProviderProps) {
      //   if (!isRemoteFiltering() && !_.isEqual(nextProps.data, this.data)) {
      //   // this.data has already been filtered
      //   this.doFilter(nextProps, this.isEmitDataChange);
      //   } else {
      //   // this.data is as SAME as nextProps.data
      //   this.data = nextProps.data;
      //   }
      // }
    }, {
      key: "doFilter",
      value: function doFilter(props) {
        var ignoreEmitDataChange = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
        var dataChangeListener = props.dataChangeListener,
          data = props.data,
          columns = props.columns,
          filter = props.filter;
        var result = (0, filter_1.filters)(data, columns, _)(this.currFilters, this.clearFilters);
        if (filter.afterFilter) {
          filter.afterFilter(result, this.currFilters);
        }
        this.data = result;
        if (dataChangeListener && !ignoreEmitDataChange) {
          this.isEmitDataChange = true;
          dataChangeListener.emit("filterChanged", result.length);
        } else {
          this.isEmitDataChange = false;
          this.forceUpdate();
        }
      }
    }, {
      key: "render",
      value: function render() {
        return react_1["default"].createElement(FilterContext.Provider, {
          value: {
            data: this.data,
            onFilter: this.onFilter,
            onExternalFilter: this.onExternalFilter,
            currFilters: this.currFilters
          }
        }, this.props.children);
      }
    }]);
    return FilterProvider;
  }(react_1["default"].Component);
  FilterProvider.propTypes = {
    data: prop_types_1["default"].array.isRequired,
    columns: prop_types_1["default"].array.isRequired,
    dataChangeListener: prop_types_1["default"].object
  };
  return {
    Provider: FilterProvider,
    Consumer: FilterContext.Consumer
  };
};